#!/usr/bin/perl

####################################################################
# Markus Schiesser
# Linux-Perl-Tk-SerialPort is used
# 14.6.2003
# extendet to eight lamps
# 31.12.2004
#m.schiesser1@gmx.de
# For free use!!
####################################################################


use warnings;
use Tk;
use Device::SerialPort 0.12;

# use port
$PORT = "/dev/ttyS0";


#declaratin variables

my ($mw, $s_light);
my ($f1);

#configure Port
$ob = Device::SerialPort -> new ($PORT) || die "Cant open port!"; 
$ob->baudrate(9600)     || die "fail set bautrate";
$ob->parity("none")     || die "fial set parity";
$ob->databits(8)        || die "fail set databits";
$ob->handshake("none")  || die "fail set handshake";
$ob->write_settings     || die "no settings";

#clear serial buffer
$ob->lookclear();

#create main window
$mw = MainWindow->new();
$f1 = $mw->Frame() -> pack();

$s1_light = $f1->Scale  (-from 		=> 0,
		        -to             => 100,
			-tickinterval 	=> 10,
			-length 	=> 284,
			-orient 	=> "horizontal",
			-label		=> "Dimmer 1",
			-command 	=> \&light_up);


$s2_light = $f1->Scale  (-from 		=> 0,
			-to		=> 100,
			-tickinterval 	=> 10,
			-length 	=> 284,
			-orient 	=> "horizontal",
			-label		=> "Dimmer 2",
			-command 	=> \&light_up);



$s3_light = $f1->Scale  (-from 		=> 0,
			-to		=> 100,
			-tickinterval 	=> 10,
			-length 	=> 284,
			-orient 	=> "horizontal",
			-label		=> "Dimmer 3",
			-command 	=> \&light_up);

$s4_light = $f1->Scale  (-from 		=> 0,
			-to		=> 100,
			-tickinterval 	=> 10,
			-length 	=> 284,
			-orient 	=> "horizontal",
			-label		=> "Dimmer 4",
			-command 	=> \&light_up);

$s5_light = $f1->Scale  (-from 		=> 0,
			-to		=> 100,
			-tickinterval 	=> 10,
			-length 	=> 284,
			-orient 	=> "horizontal",
			-label		=> "Dimmer 5",
			-command 	=> \&light_up);

$s6_light = $f1->Scale  (-from 		=> 0,
			-to		=> 100,
			-tickinterval 	=> 10,
			-length 	=> 284,
			-orient 	=> "horizontal",
			-label		=> "Dimmer 6",
			-command 	=> \&light_up);

$s7_light = $f1->Scale  (-from 		=> 0,
			-to		=> 100,
			-tickinterval 	=> 10,
			-length 	=> 284,
			-orient 	=> "horizontal",
			-label		=> "Dimmer 7",
			-command 	=> \&light_up);

$s8_light = $f1->Scale  (-from 		=> 0,
			-to		=> 100,
			-tickinterval 	=> 10,
			-length 	=> 284,
			-orient 	=> "horizontal",
			-label		=> "Dimmer 8",
			-command 	=> \&light_up);

			
$s1_light -> pack(-side => "top");
$s2_light -> pack;
$s3_light -> pack;
$s4_light -> pack;
$s5_light -> pack;
$s6_light -> pack;
$s7_light -> pack;
$s8_light -> pack(-side => "bottom");

$s1_light->set(0);
$s2_light->set(0);
$s3_light->set(0);
$s4_light->set(0);
$s5_light->set(0);
$s6_light->set(0);
$s7_light->set(0);
$s8_light->set(0);

MainLoop;

sub light_up {
#
# debug
#print  $s1_light -> get(), $s2_light -> get(), $s3_light -> get(), $s4_light -> get(), $s5_light -> get(), $s6_light -> get(), $s7_light -> get(), $s8_light -> get(),"\n";


$ob -> write (chr $s1_light -> get());
$ob -> write (chr $s2_light -> get());
$ob -> write (chr $s3_light -> get());
$ob -> write (chr $s4_light -> get());
$ob -> write (chr $s5_light -> get());
$ob -> write (chr $s6_light -> get());
$ob -> write (chr $s7_light -> get());
$ob -> write (chr $s8_light -> get());
} 
